package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.BaseConverterImpl;
import com.jasamedika.medifirst2000.dao.AntrianPasienDiPeriksaDao;
import com.jasamedika.medifirst2000.dao.KelahiranDao;
import com.jasamedika.medifirst2000.entities.AntrianPasienDiPeriksa;
import com.jasamedika.medifirst2000.entities.Kelahiran;
import com.jasamedika.medifirst2000.entities.PasienDaftar;
import com.jasamedika.medifirst2000.entities.ProsesKelahiran;
import com.jasamedika.medifirst2000.entities.StatusYaTidak;
import com.jasamedika.medifirst2000.service.KelahiranService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.AntrianPasienDiPeriksaVO;
import com.jasamedika.medifirst2000.vo.KelahiranVO;
import com.jasamedika.medifirst2000.vo.PasienDaftarVO;
import com.jasamedika.medifirst2000.vo.ProsesKelahiranVO;
import com.jasamedika.medifirst2000.vo.StatusYaTidakVO;

/**
 * @author Teguh
 */

@Service("KelahiranService")
public class KelahiranServiceImpl implements KelahiranService{
	
	@Autowired
	private KelahiranDao kelahiranDao;
	
	@Autowired
	private BaseConverterImpl<KelahiranVO,Kelahiran> kelahiranConverter;
	
	@Autowired
	private BaseConverterImpl<ProsesKelahiranVO,ProsesKelahiran> prosesKelahiranConverter;
	
	@Autowired
	private BaseConverterImpl<StatusYaTidakVO,StatusYaTidak> bantuanPernapasanConverter;
	
	@Autowired
	private BaseConverterImpl<AntrianPasienDiPeriksaVO,AntrianPasienDiPeriksa> pasienDaftarConverter;
	@Autowired
	private AntrianPasienDiPeriksaDao antrianPasienDiPeriksaDao;
	@Override
	public Map<String,Object> addKelahiran(KelahiranVO vo) {

		Kelahiran kelahiran=new Kelahiran();
				
		if(CommonUtil.isNotNullOrEmpty(vo)){
			kelahiran=kelahiranConverter.transferVOToModel(vo, new Kelahiran());
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getBantuanPernapasan())){
			kelahiran.setBantuanPernapasan(bantuanPernapasanConverter.transferVOToModel(vo.getBantuanPernapasan(), new StatusYaTidak()));
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getProsesKelahiran())){
			kelahiran.setProsesKelahiran(prosesKelahiranConverter.transferVOToModel(vo.getProsesKelahiran(), new ProsesKelahiran()));
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getPasienDaftar())){
			kelahiran.setPasien(pasienDaftarConverter.transferVOToModel(vo.getPasienDaftar(), new AntrianPasienDiPeriksa()));
		}
		
		Kelahiran kelahiranResult=kelahiranDao.save(kelahiran);
		
		Map<String,Object> result=new HashMap<String,Object>();
		
		if (CommonUtil.isNotNullOrEmpty(kelahiranResult)) {
			result.put("noRec", kelahiranResult.getNoRec());
			result.put("panjang", kelahiranResult.getPanjang());
		}
		
		return result;
		
	}
	
	@Override
	public Map<String,Object> updateKelahiran(KelahiranVO vo) {

		Kelahiran kelahiran=new Kelahiran();
				
		if(CommonUtil.isNotNullOrEmpty(vo)){
			kelahiran=kelahiranConverter.transferVOToModel(vo, new Kelahiran());
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getBantuanPernapasan())){
			kelahiran.setBantuanPernapasan(bantuanPernapasanConverter.transferVOToModel(vo.getBantuanPernapasan(), new StatusYaTidak()));
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getProsesKelahiran())){
			kelahiran.setProsesKelahiran(prosesKelahiranConverter.transferVOToModel(vo.getProsesKelahiran(), new ProsesKelahiran()));
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getPasienDaftar())){
			kelahiran.setPasien(pasienDaftarConverter.transferVOToModel(vo.getPasienDaftar(), new AntrianPasienDiPeriksa()));
		}
		
		Kelahiran kelahiranResult=kelahiranDao.save(kelahiran);
		
		Map<String,Object> result=new HashMap<String,Object>();
		
		if (CommonUtil.isNotNullOrEmpty(kelahiranResult)) {
			result.put("noRec", kelahiranResult.getNoRec());
			result.put("panjang", kelahiranResult.getPanjang());
		}
			
		return result;
		
	}

}
